<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
  <script src = "https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
</head>

<body onload="onPageLoading()">
  <h1 class="text-center">Quản trị người dùng</h1>
  <div class="container-fluid jumbotron">
    <div class="row">
      <div class="col-sm-3 text-center">
        Role
      </div>
      <div class="col-sm-6">
        <select id="select-role" class="form-control">
          <option class="text-center">-----Chọn một role-----</option>
        </select>
      </div>
      <div class="col-sm-3">
        <button class="btn btn-success" id="btn-filter-order" style="color: aliceblue;">Lọc dữ liệu</button>
      </div>
    </div>
  </div>
  <div class="container-fluid">
    <table class="table table-bordered table-striped table-hover" id="table-user">
      <thead style="background-color: darkblue; color: aliceblue;">
        <th>STT</th>
        <th>User name</th>
        <th>First name</th>
        <th>Last name</th>
        <th>Email</th>
        <th>Age</th>
        <th>Role</th>
        <th>Action</th>
      </thead>
    </table>
  </div>
<script>
  
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13
        }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin" 
        },
        {
          roleId: 8,
          roleName: "Manager" 
        },
        {
          roleId: 11,
          roleName: "Teacher" 
        },
        {
          roleId: 13,
          roleName: "Staff" 
        }
  ];
  
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  var gStt = 1;

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
  function onPageLoading(){
    hienDuLieuLenBang (gUserObjects);
    for (var vIndex = 0; vIndex <gRoleObjects.length; vIndex++){
        $("#select-role").append('<option value = "' + gRoleObjects[vIndex].roleId+ '">' + gRoleObjects[vIndex].roleName + '</option>');
    }
  }

  // Hàm xử lý sự kiện khi bấm nút btn-filter-order
  $("#btn-filter-order").on("click", function(){
    var vFilteredRole = gUserObjects.filter(filterRoleObject);
    reloadTable (vFilteredRole);
    //hienDuLieuLenBang (vFilteredOrder);
  });

  $("#table-user").on("click", "#dice", function () {
      onBtnDiceUserClick(this);
  });
  
  function onBtnDiceUserClick(paramBtnDice){
    const vDETAIL_FORM_URL = "diceHistory.html";
    var vUrlOpenSiter = vDETAIL_FORM_URL + 
    "?user_name=" + paramBtnDice.username +
    "&first_name=" + paramBtnDice.firstname +
    "&last_name=" + paramBtnDice.lastname;
    window.location.href=vUrlOpenSiter;
  }
  

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function hienDuLieuLenBang (paramUserArray){
    var vTable = $("#table-user").DataTable(
      {
        data: paramUserArray,
        columns: [
          {data: "id"},
          {data: "username"},
          {data: "firstname"},
          {data: "lastname"},
          {data: "email"},
          {data: "age"},
          {data: "roleId"},
          {data: "action"}
        ],
        columnDefs: [
          {
            target: 0,
            render: function (){
              return gStt++;
            }
          },
          {
            target: 6,
            render: function(data){
              for(var bI = 0; bI<gRoleObjects.length; bI++){
                if(gRoleObjects[bI].roleId === data){
                  return gRoleObjects[bI].roleName;
                }
              }
              return data;
            }
          },
          {
            target: 7,
            "defaultContent": `
              <button class="btn btn-link" id="dice" data-toggle="tooltip" data-placement="bottom" title="Dice History"><i class="fas fa-dice text-success"></i></button> 
              <button class="btn btn-link btn-sm" id="voucher" data-toggle="tooltip" data-placement="bottom" title="Voucher History"><i class="fas fa-gift text-success"></i></button>
            `
          }
        ]
      }
    )
  }
  // Hàm filter dữ liệu
  function filterRoleObject(paramRoleElement){
    return paramRoleElement.roleId == $("#select-role").val();
  }

  function reloadTable (paramUserArray){
    var vTable = $("#table-user").DataTable().clear();
    vTable.rows.add(paramUserArray);
    vTable.draw();
  }
</script>
</body>
</html>